<?php

class Config 
{
	public function __construct() {
	
		if (self::$config) return self::$config;
		
		global $def; //это массив, иначе класс Config не будет найден
		$def += array(
			'ext' => '.htm',
			
			'page' => array(
				'doctype' => '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">',
				'metas' => '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />',
				'styles' => '<link rel="stylesheet" href="style.css" type="text/css">',
			),
			
			'meta' => array( /* Model */
				'install' => array('table' => 'system', 'title' => 'Установка', 'count' => intval(file_exists($def['site_path'] . '/install'))),
				'friends' => array('table' => 'people', 'title' => 'Друзья', 'flag' => 'rel', 'count' => 3),
				'enemies' => array('table' => 'people', 'title' => 'Враги', 'flag' => 'rel', 'count' => 2),
				'cats' => array('table' => 'cats', 'title' => 'Кошки', 'count' => 1),
				'jobs' => array('table' => 'jobs', 'title' => 'Задачи', 'count' => 1),
			),
			'show' => 'ru', /* Model */
			
		);

		$def['default_url'] = 'friends' . $def['ext'];

		
		$env_arr = array();
		foreach($_ENV as $k => $v) $env_arr[$k] = $_ENV[$k];
		foreach($_SERVER as $k => $v) $env_arr[$k] = $_SERVER[$k];
		
		$short_def = array(
			'host' => 'HTTP_HOST',
			'uri' => 'REQUEST_URI',
			'match' => 'HTTP_IF_NONE_MATCH',
			'since' => 'HTTP_IF_MODIFIED_SINCE',
			'agent' => 'HTTP_USER_AGENT',
			'script_path' => 'SCRIPT_FILENAME', 
			'referer' => 'HTTP_REFERER', 
			'server_ip' => 'SERVER_ADDR',
			'server_port' => 'SERVER_PORT',
			'klient_ip' => 'REMOTE_ADDR', 
			'docroot' => 'DOCUMENT_ROOT'
		);
		
		foreach($short_def as $k => $v) {
			$add = (isset($env_arr[$v])) ? $env_arr[$v] : '';
			if (strpos($add, '\\') !== false) $add = str_replace('\\', '/', $add);
			$env_arr[$k] = $add;
		}
		
		$pre_def = parse_ini_file($def['site_path'] . '/site.ini', true);
		$pre_def['env'] = $env_arr;
		$def += $pre_def;
		$def['dsn']['TZ_offset'] = (strtotime(date("Y-m-d H:i:s")) - strtotime(gmdate("Y-m-d H:i:s")))/60/60;
		$def['dsn']['charset'] = 'cp1251';

		//местная коррекция
		$mesto = $env_arr['docroot'] . '/../moe_mesto.php';
		$mesto_conf = (file_exists($mesto)) ? $def['lib'] . '/platforms/' . (include $mesto) . '.php' : null;
		if ($mesto_conf && file_exists($mesto_conf)) include($mesto_conf);
		
		self::$config = $pre_def;
		return self::$config;
	}
	
	public static $config = null;
}
