<?php

class Data extends Model {
	
	protected $data;
	protected $subj;
	protected $id;
	
	public function __construct($subj, $id) {
		
		parent::__construct();
		
		if (!$subj) $subj = esse($def, 'subj');
		if (!$id) $id = esse($def, 'id');
		$this->subj = $subj;
		$this->id = $id;
		
		$this->data = array(
			'people' => array(
				1 => array('id' => 1, 'name' => "Александр", 'year' => "1985", 'descr' => "Лучший друг", 'email' => "alex@mail.com", 'rel' => "friends"),
				2 => array('id' => 2, 'name' => "Юрий", 'year' => "1987", 'descr' => "Друг средней степени", 'email' => "yury@gmail.com", 'rel' => "friends"),
				3 => array('id' => 3, 'name' => "Алексей", 'year' => "1989", 'descr' => "Очень сомнительный друг: может занять максимум 2-3 тысячи р.", 'email' => "alexey@yahoo.com", 'rel' => "friends"),
				4 => array('id' => 4, 'name' => "Джо", 'year' => "1909", 'descr' => "Somebody", 'email' => "joe@yahoo.com", 'rel' => "enemies"),
				5 => array('id' => 5, 'name' => "Джесси", 'year' => "1919", 'descr' => "Ведьма", 'email' => "jessie@yahoo.com", 'rel' => "enemies"),
			),
			'cats' => array(
				1 => array('id' => 1, 'name' => "Вася", 'year' => "1993", 'descr' => "Очень лохматый и чёрный"),
			),
			'system' => array(
				1 => array('id' => 1, 'name' => 'Установить БД', 'descr' => 'Существующие таблицы не будут перезаписаны'),
				2 => array('id' => 2, 'name' => 'Переустановить БД', 'descr' => 'Существующие таблицы сначала будут уничтожены'),
			),
			'jobs' => array(
			),
		);
		
		$this->data = $this->set_data();
		$this->get();
	}
	
	public function get() {
		global $def;
		$view = $def['view'];
		$method = 'get_' . $view;
		$arr = array();
		$arr['menu'] = $this->get_menu();
		$arr[$view] = $this->$method();
		return $arr;
	}
	
	public function set_data() {
		
		global $def;
		$meta = $def['meta'][$this->subj];
		$table = $meta['table'];
		$def['sql_table'] = $table;
		$table = $this->data[$table];
		
		if (empty($meta['flag'])) return (count($table)) ? $table : def_404();
		$flag = $meta['flag'];
		$flag_value = $this->subj;
		
		$arr = array();
		foreach ($table as $key => $row) {
			if ($row[$flag] == $flag_value) $arr[$key] = $row;
		}
		
		return (count($arr)) ? $arr : def_404();
	}
	
	public function get_item() {
		global $def;
		$table = $def['sql_table'];
		$meta = $def['meta'][$this->subj];
		$title = $meta['title'];
		$id = $this->id;
		
		$fields = $this->fields[$table];
		$data = esse($this->data, $id);
		if (empty($data)) return def_404();
		$item = $this->get_row($fields, $data);
		
		return array('item' => $item, 'title' => $title . ': ' . $item['name'][0]);
	}
	
	public function get_table() {
		global $def;
		$table = $def['sql_table'];
		$meta = $def['meta'][$this->subj];
		$title = $meta['title'];
		
		$fields = $this->fields[$table];
		$data = $this->data;
		$thead = array();
		$tbody = array();
		
		foreach ($fields as $field => $prop) {
			if (empty($prop['list'])) continue;
			$thead[$field] = $prop;
		}
		
		foreach ($data as $key => $value) {
			$tbody[] = $this->get_row($thead, $value, $this->subj);
		}
		
		return array('caption' => $title, 'thead' => $thead, 'tbody' => $tbody, 'title' => $title);
	}
	
	private function get_row(&$arr, &$data, $subj = false) { //нижний / уровень : def_e!!
		$row = array();
		foreach ($arr as $field => $prop) {
			if (!empty($prop['ru'])) {
				$extra = ($subj) ? false : $prop['ru'];
				$tpl = false;
				
				if (!empty($prop['link']) && $subj) {
					$extra = urlencode($subj) . '?id=' . urlencode($data[$prop['link']]);
					$tpl = 'a';
				}
				$row[$field] = array(def_e($data[$field]), $extra, $tpl);
			}
		}
		return $row;
	}
	
	public function get_menu() { //нижний / уровень : def_e!!
		global $def; 
		$meta = $def['meta'];
		
		$menu = array();
		foreach ($meta as $subj => $arr) {
			$file = $subj . $def['ext'];
			if ($file == $def['file']) $file = false;
			
			if ($arr['count']) //наличие данных
				$menu[] = array('href' => urlencode($file), 'text' => def_e($arr['title']));
		}
		
		return $menu;
	}
	
	
}
