<?php

class View {
	
	protected $data;
	protected $subj;
	protected $id;
	
	public function __construct($subj, $id) {
		global $def;
		if (!$subj) $subj = esse($def, 'subj');
		if (!$id) $id = esse($def, 'id');
		$this->subj = $subj;
		$this->id = $id;
		$data = new Data($subj, $id);
		$data = $data->get();
		$this->data = $data;
		$this->out();
	}
	
	public function out() {
		global $def;
		$arr = array();
		$method = 'tpl_' . (($def['id']) ? 'item' : 'table');
		$arr['title'] = $this->data[$def['view']]['title'];
		$arr['menu'] = $this->build_menu();
		$arr['body'] = $this->$method();
				
		$arr['footer'] = ($def['id']) ? '' : <<<TPL
	<div class='distr'>
	<h4><a href='./repa/'>дистрибутивы</a> анти-мвц (версии)</h4>
	<p><a href='http://ir2.ru/php_framework.aspx'>php-фреймворк анти-мвц-ооп</a>, описание</p>
	</div>
TPL;
		print $this->tpl_page($arr);
	}
	
	public static function htpl() {
		$def = array(
			'img' => array('src', 'alt'),
			'a' => array('href'),
		);
		
		$args = func_get_args();
		if (is_array($args[0])) $args = $args[0];
		$mode = intval(array_shift($args));
		$tag = array_shift($args);
		if (!count($args)) $args = esse($def, $tag);
		if (!$args) $args = array();
		$attrs = '';
		
		foreach ($args as $key => $attr) $attrs .= ' ' . $attr . '="%' . ($key + $mode) . "\$s\" ";
		
		return ($mode == 1) ? '<' . $tag . $attrs . ' />' 
			: '<' . $tag . $attrs . ">%1\$s</" . $tag . '>';
		
	}
	
	protected function build_menu() {
		$menu = $this->data['menu'];
		$out = array();
		foreach($menu as $arr) {
			$out[] = (!empty($arr['href'])) 
				? sprintf(self::htpl(2, 'a', 'href'), $arr['text'], $arr['href'])
				: sprintf(self::htpl(2, 'span'), $arr['text']);
		}
		return implode(' | ', $out);
	}
		
	function tpl_page(&$arr) {
		global $def;
		
		//перекрытие
		$default = array(
			'doctype' => esse($def, 'page', 'doctype'),
			'metas' => esse($def, 'page', 'metas'),
			'styles' => esse($def, 'page', 'styles'),
			'scripts' => esse($def, 'page', 'scripts'),
			'title' => esse($arr, 'title'),
			'body_attrs' => esse($arr, 'body_attrs'),
			'header' => esse($arr, 'header'),
			'menu' => esse($arr, 'menu'),
			'body' => esse($arr, 'body'),
			'footer' => esse($arr, 'footer'),
		);
		if (empty($default['title'])) $default['title'] = $def['title'];
		//вот и весь "интерфейс"!
		
		extract($default);
		return <<<TPL
{$doctype}
<head>
	{$metas}
	<title>{$title}</title>
	{$styles}
	{$scripts}
</head>
<body{$body_attrs}>
	{$header}
	<div class="menutop">{$menu}</div>	
	{$body}
	{$footer}
</body>

TPL;
	} //function tpl_page
	
	//subclass Table
	
	public function tpl_table() {
		global $def;
		
		$caption = $this->data[$def['view']]['caption'];
		$head = $this->build_head();
		$thead = $head['thead'];
		$cols = $head['cols'];
		$tbody = $this->build_tbody();

		return <<<TPL
<table class="{$def['sql_table']}">
	<caption>{$caption}</caption>
	<colgroup>{$cols}</colgroup>
	<thead>{$thead}</thead>
	<tbody>{$tbody}</tbody>
</table>
TPL;
	}
	
	public function build_head() {
		global $def;
		
		$head = $this->data['table']['thead'];
		
		$thead = '<tr>';
		$cols = '';
		foreach($head as $field => $prop) {
			if (!empty($prop[$def['show']])) {
				$thead .= sprintf(self::htpl(2, 'th', 'class'), $prop[$def['show']], $field);
				$cols .= sprintf(self::htpl(1, 'col', 'class'), $field);
			}
		}
		$thead .= '</tr>';
		return array('thead' => $thead, 'cols' => $cols);
	}
	
	public function build_tbody() {
		global $def;
		
		$thead = $this->data['table']['thead'];
		$tbody = $this->data['table']['tbody'];
		$str = '';
		
		foreach($tbody as $row) {
			
			$str .= '<tr>';
			foreach($thead as $field => $prop) {
				if (!empty($prop[$def['show']])) {
					$value = $row[$field];
					$html = (!empty($value[2])) 
					? sprintf(self::htpl(2, $value[2]), $value[0], $value[1]) 
					: $value[0];
					
					$str .= sprintf(self::htpl(2, 'td'), $html);
				}
			}
			$str .= '</tr>';
		}
		
		return $str;
	
	} //subclass Table
	
	//subclass Item
	
	public function tpl_item() {
		$item = $this->build_item();
		return <<<TPL
<div class="item">
	
	{$item}
</div>
TPL;
	}
	public function build_item() {
		global $def;
		
		$item = $this->data[$def['view']]; //!!sic
		$str = '';
		$alt = '';
		foreach($item['item'] as $name => $it) {
			if (!$alt) $alt = $it[0]; //тупо
			$html = sprintf(self::htpl(2, 'strong'), $it[1]) . ': ' . $it[0];
			$str .= sprintf(self::htpl(2, 'p'), $html);
		}
		$img = 'img/' . $def['id'] . '.gif';
		
		if (file_exists($def['site_path'] . '/' . $img))
			$str .= sprintf(self::htpl(1, 'img'), $img, $alt);
		
		return $str;
	} //subclass Item
	
} //class View